static const char *RcsId = "$Id: Keithley2182A.cpp,v 1.2 2013-02-27 08:58:22 sminolli Exp $";
//+=============================================================================
//
// file :         Keithley2182A.cpp
//
// description :  C++ source for the Keithley2182A and its commands. 
//                The class is derived from Device. It represents the
//                CORBA servant object which will be accessed from the
//                network. All commands which can be executed on the
//                Keithley2182A are implemented in this file.
//
// project :      TANGO Device Server
//
// $Author: sminolli $
//
// $Revision: 1.2 $
//
// $Revision: 1.2 $
// $Date: 2013-02-27 08:58:22 $
//
// SVN only:
// $HeadURL: $
//
// CVS only:
// $Source: /users/chaize/newsvn/cvsroot/Instrumentation/Keithley2182A/src/Keithley2182A.cpp,v $
// $Log: not supported by cvs2svn $
// Revision 1.1  2013/02/14 14:53:51  olivierroux
// - initial import bug#24564
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================



//===================================================================
//
//	The following table gives the correspondence
//	between commands and method name.
//
//  Command name  |  Method name
//	----------------------------------------
//  State         |  dev_state()
//  Status        |  dev_status()
//  SelectCH1     |  select_ch1()
//  SelectCH2     |  select_ch2()
//  AutoRangeON   |  auto_range_on()
//  AutoRangeOFF  |  auto_range_off()
//  RangeUP       |  range_up()
//  RangeDOWN     |  range_down()
//  GetRange      |  get_range()
//
//===================================================================


#include <tango.h>
#include <Keithley2182A.h>
#include <Keithley2182AClass.h>
#include <TypesAndConsts.h>

namespace Keithley2182A_ns
{

//-----------------------------------------------------------------------------
//- Check Interface macro:
#define CHECK_INTERFACE \
    if (! this->m_interface) \
    { \
      THROW_DEVFAILED(_CPTC("INTERNAL_ERROR"), \
                      _CPTC("request aborted - the GPIB Interface isn't properly initialized"), \
                      _CPTC("Keithley2182A::check_interface")); \
    }

//+----------------------------------------------------------------------------
//
// method : 		Keithley2182A::Keithley2182A(string &s)
// 
// description : 	constructor for simulated Keithley2182A
//
// in : - cl : Pointer to the DeviceClass object
//      - s : Device name 
//
//-----------------------------------------------------------------------------
Keithley2182A::Keithley2182A(Tango::DeviceClass *cl,string &s)
:Tango::Device_4Impl(cl,s.c_str())
{
	init_device();
}

Keithley2182A::Keithley2182A(Tango::DeviceClass *cl,const char *s)
:Tango::Device_4Impl(cl,s)
{
	init_device();
}

Keithley2182A::Keithley2182A(Tango::DeviceClass *cl,const char *s,const char *d)
:Tango::Device_4Impl(cl,s,d)
{
	init_device();
}
//+----------------------------------------------------------------------------
//
// method : 		Keithley2182A::delete_device()
// 
// description : 	will be called at device destruction or at init command.
//
//-----------------------------------------------------------------------------
void Keithley2182A::delete_device()
{
	yat4tango::TraceHelper t("Keithley2182A::delete_device", this);

	//	Delete device allocated objects
	if(m_interface)
  {
		delete m_interface;
	  m_interface = 0;
  }

	if(m_deviceProxy)
  {
		delete m_deviceProxy;
	  m_deviceProxy = 0;
  }

	//- remove the inner appender
	yat4tango::InnerAppender::release(this);
}

//+----------------------------------------------------------------------------
//
// method : 		Keithley2182A::init_device()
// 
// description : 	will be called at device initialization.
//
//-----------------------------------------------------------------------------
void Keithley2182A::init_device()
{
	m_autoRange1 = false;
	m_autoRange2 = false;
	m_channel = CHANNEL_UNKNOWN;
	m_range_1 = "";
	m_range_2 = "";
	//- initialize the inner appender (first thing to do)
	try
	{
		yat4tango::InnerAppender::initialize(this, 512);
	}
	catch( Tango::DevFailed& df )
	{
		ERROR_STREAM << df << std::endl;
		set_state(Tango::FAULT);
		set_status( "initialization failed - could not instanciate the InnerAppender");
		return;
	}

	//- trace/profile this method
	yat4tango::TraceHelper t("Keithley2182A::init_device", this);

	// Initialise variables to default values
	//--------------------------------------------
	try
	{
		this->get_device_property();
	}
	catch (Tango::DevFailed & df)
	{
		ERROR_STREAM << df << std::endl;
		set_status ("initialization failed - <get_device_property> failed [see device log for details]");
		set_state (Tango::FAULT);
		return;
	}
	catch (...)
	{
		ERROR_STREAM << "initialization failed - unknown <get_device_property> error" << std::endl;
		set_status ("initialization failed [unknown <get_device_property> error]");
		set_state (Tango::FAULT);
		return;
	}

	//- get access to the gpib device
	try
	{
		m_deviceProxy = new Tango::DeviceProxy(gpibDeviceName);
		int l_res = m_deviceProxy->ping();
		DEBUG_STREAM << "The GpibDevice proxy pings at" << l_res << std::endl;
	}
	catch (...)
	{
		ERROR_STREAM << "initialization failed - failed to access the gpibDevice" << std::endl;
		set_status ("initialization failed [failed to access the gpibDevice]");
		set_state (Tango::FAULT);
		return;
	}

	try
	{
		m_interface = new nanoVoltInterface(m_deviceProxy);

    CHECK_INTERFACE;

		//- check if the identification is accessible, if not, The gpib device isn't well configured or the equipment is off or not connected.
	  std::string l_strid = m_interface->read_id();
	  DEBUG_STREAM << "initialization : ID : " << l_strid << std::endl;
	}
	catch (...)
	{
		ERROR_STREAM << "initialization failed - failed to create interface. The gpib device isn't well configured or the equipment is off or not connected." << std::endl;
		this->set_status ("initialization failed [failed to create interface]\nThe gpib device isn't well configured or the equipment is off or not connected.");
		this->set_state (Tango::FAULT);
		return;
	}

	//- set the equipment in initial conditions
	m_interface->set_channel_1();
	m_channel = 1;
	m_autoRange1 = m_interface->read_autorange_1();
	m_range_1 = Tango::string_dup(m_interface->read_range_1().data());
	m_autoRange2 = m_interface->read_autorange_2();
	m_range_2 = Tango::string_dup(m_interface->read_range_2().data());

	set_state(Tango::RUNNING);
	set_status("The nanovoltmeter is acquiring");
}


//+----------------------------------------------------------------------------
//
// method : 		Keithley2182A::get_device_property()
// 
// description : 	Read the device properties from database.
//
//-----------------------------------------------------------------------------
void Keithley2182A::get_device_property()
{

	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read device properties from database.(Automatic code generation)
	//------------------------------------------------------------------
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("GpibDeviceName"));

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_device()->get_property(dev_prop);
	Tango::DbDatum	def_prop, cl_prop;
	Keithley2182AClass	*ds_class =
		(static_cast<Keithley2182AClass *>(get_device_class()));
	int	i = -1;

	//	Try to initialize GpibDeviceName from class property
	cl_prop = ds_class->get_class_property(dev_prop[++i].name);
	if (cl_prop.is_empty()==false)	cl_prop  >>  gpibDeviceName;
	else {
		//	Try to initialize GpibDeviceName from default device value
		def_prop = ds_class->get_default_device_property(dev_prop[i].name);
		if (def_prop.is_empty()==false)	def_prop  >>  gpibDeviceName;
	}
	//	And try to extract GpibDeviceName value from database
	if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  gpibDeviceName;



	//	End of Automatic code generation
	//------------------------------------------------------------------

	//- check the device name
	if (gpibDeviceName.empty() == true)
	{
		set_state(Tango::FAULT);
		set_status("The gpib device name must be filled");
		ERROR_STREAM << "The gpib device name must be filled" << std::endl;
		THROW_DEVFAILED(_CPTC("CONFIGURATION_ERROR"),
			_CPTC("The gpib device name must be filled"),
			_CPTC("Keithley2182A::get_device_property "));
	}

}
//+----------------------------------------------------------------------------
//
// method : 		Keithley2182A::always_executed_hook()
// 
// description : 	method always executed before any command is executed
//
//-----------------------------------------------------------------------------
void Keithley2182A::always_executed_hook()
{
	
}
//+----------------------------------------------------------------------------
//
// method : 		Keithley2182A::read_attr_hardware
// 
// description : 	Hardware acquisition for attributes.
//
//-----------------------------------------------------------------------------
void Keithley2182A::read_attr_hardware(vector<long> &attr_list)
{
	//DEBUG_STREAM << "Keithley2182A::read_attr_hardware(vector<long> &attr_list) entering... "<< endl;
	//	Add your own code here
}

//+----------------------------------------------------------------------------
//
// method : 		Keithley2182A::read_channel
// 
// description : 	Extract real attribute values for channel acquisition result.
//
//-----------------------------------------------------------------------------
void Keithley2182A::read_channel(Tango::Attribute &attr)
{
  CHECK_INTERFACE;

	//DEBUG_STREAM << "Keithley2182A::read_channel(Tango::Attribute &attr) entering... "<< endl;
	
  if (get_state() != Tango::FAULT)
	{
		try
		{
			m_channel = m_interface->read_channel();
		}
		catch (...)
		{
			set_state(Tango::FAULT);
			set_status("Problem communicating with the GPIB device");
			THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
				_CPTC("Problem communicating with the GPIB device"),
				_CPTC("Keithley2182A::read_channel"));
		}
		attr.set_value(&m_channel);
	}
}

//+----------------------------------------------------------------------------
//
// method : 		Keithley2182A::read_value
// 
// description : 	Extract real attribute values for value acquisition result.
//
//-----------------------------------------------------------------------------
void Keithley2182A::read_value(Tango::Attribute &attr)
{
  CHECK_INTERFACE;

	//DEBUG_STREAM << "Keithley2182A::read_value(Tango::Attribute &attr) entering... "<< endl;
	
  if (get_state() != Tango::FAULT)
	{
		try
		{
			m_value = m_interface->read_value();
		}
		catch (Tango::DevFailed &e)
		{
			if (strcmp(e.errors[0].reason.in(), "HARDWARE_FAILURE") == 0)
			{
				set_state(Tango::ALARM);
				set_status("HARDWARE FAILURE - The nanovoltmeter is in OVERFLOW.\nTry to change the range or use the autorange function");
				THROW_DEVFAILED(_CPTC("HARDWARE_FAILURE"),
					_CPTC("The nanovoltmeter is in OVERFLOW"),
					_CPTC("Keithley2182A::read_Value"));
			}

			DEBUG_STREAM << "Keithley2182A::read_value(Tango::Attribute &attr) entering... "<< e << endl;
			set_state(Tango::FAULT);
			set_status("Problem communicating with the GPIB device");
			
      THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
				_CPTC("Problem communicating with the GPIB device"),
				_CPTC("Keithley2182A::read_value"));;
		}
		attr.set_value(&m_value);
		set_state(Tango::RUNNING);
		set_status("The nanovoltmeter is acquiring");
	}
}

//+----------------------------------------------------------------------------
//
// method : 		Keithley2182A::read_range
// 
// description : 	Extract real attribute values for range acquisition result.
//
//-----------------------------------------------------------------------------
void Keithley2182A::read_range(Tango::Attribute &attr)
{
  CHECK_INTERFACE;

	//DEBUG_STREAM << "Keithley2182A::read_range(Tango::Attribute &attr) entering... "<< endl;
	
  if (get_state() != Tango::FAULT)
	{
		if (m_channel == CHANNEL1)
		{
			try
			{
				m_range_1 = Tango::string_dup(m_interface->read_range_1().data());
			}
			catch (...)
			{
				set_state(Tango::FAULT);
				set_status("Problem communicating with the GPIB device");
				THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
					_CPTC("Problem communicating with the GPIB device"),
					_CPTC("Keithley2182A::read_range"));
			}
			attr.set_value(&m_range_1);
		}

		if (m_channel == CHANNEL2)
		{
			try
			{
				m_range_2 = Tango::string_dup(m_interface->read_range_2().data());
			}
			catch (...)
			{
				set_state(Tango::FAULT);
				set_status("Problem communicating with the GPIB device");
				THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
					_CPTC("Problem communicating with the GPIB device"),
					_CPTC("Keithley2182A::read_range"));
			}
			attr.set_value(&m_range_2);
		}
	}
}

//+----------------------------------------------------------------------------
//
// method : 		Keithley2182A::read_autoRange
// 
// description : 	Extract real attribute values for autoRange acquisition result.
//
//-----------------------------------------------------------------------------
void Keithley2182A::read_autoRange(Tango::Attribute &attr)
{
  CHECK_INTERFACE;

	//DEBUG_STREAM << "Keithley2182A::read_autoRange(Tango::Attribute &attr) entering... "<< endl;
	
  if (get_state() != Tango::FAULT)
	{
		if (m_channel == CHANNEL1)
		{
			try
			{
				m_autoRange1 = m_interface->read_autorange_1();
			}
			catch (...)
			{
				set_state(Tango::FAULT);
				set_status("Problem communicating with the GPIB device");
				THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
					_CPTC("Problem communicating with the GPIB device"),
					_CPTC("Keithley2182A::read_autoRange"));
			}
			attr.set_value(&m_autoRange1);
		}

		if (m_channel == CHANNEL2)
		{
			try
			{
				m_autoRange2 = m_interface->read_autorange_2();
			}
			catch (...)
			{
				set_state(Tango::FAULT);
				set_status("Problem communicating with the GPIB device");
				THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
					_CPTC("Problem communicating with the GPIB device"),
					_CPTC("Keithley2182A::read_autoRange"));
			}
			attr.set_value(&m_autoRange2);
		}
	}
}



//+------------------------------------------------------------------
/**
 *	method:	Keithley2182A::select_ch1
 *
 *	description:	method to execute "SelectCH1"
 *	This command allows to select the channel 1 for the acquisition
 *
 *
 */
//+------------------------------------------------------------------
void Keithley2182A::select_ch1()
{
  CHECK_INTERFACE;

	DEBUG_STREAM << "Keithley2182A::select_ch1(): entering... !" << endl;

	//	Add your own code to control device here
	Tango::DevState st = this->get_state();
	
  if ((st == Tango::FAULT) ||
      (st == Tango::ALARM) )
	{
		THROW_DEVFAILED(
			_CPTC("BAD_STATE"),
			_CPTC("Action not allowed in this state - Device must be <RUNNING>"),
			_CPTC("Keithley2182A::select_ch1"));
	}

	try
	{
		m_interface->set_channel_1();
	}
	catch (...)
	{
		set_state(Tango::FAULT);
		set_status("Problem communicating with the GPIB device");
		THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
			_CPTC("Problem communicating with the GPIB device"),
			_CPTC("Keithley2182A::select_ch1"));
	}
	m_channel = 1;
}

//+------------------------------------------------------------------
/**
 *	method:	Keithley2182A::select_ch2
 *
 *	description:	method to execute "SelectCH2"
 *	This command allows to select the channel 2 for the acquisition
 *
 *
 */
//+------------------------------------------------------------------
void Keithley2182A::select_ch2()
{
  CHECK_INTERFACE;

	DEBUG_STREAM << "Keithley2182A::select_ch2(): entering... !" << endl;

	//	Add your own code to control device here
	Tango::DevState st = this->get_state();

	if ((st == Tango::FAULT) ||
      (st == Tango::ALARM) )
	{
		THROW_DEVFAILED(
			_CPTC("BAD_STATE"),
			_CPTC("Action not allowed in this state - Device must be <RUNNING>"),
			_CPTC("Keithley2182A::select_ch2"));
	}

	try
	{
		m_interface->set_channel_2();
	}
	catch (...)
	{
		set_state(Tango::FAULT);
		set_status("Problem communicating with the GPIB device");
		THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
			_CPTC("Problem communicating with the GPIB device"),
			_CPTC("Keithley2182A::select_ch2"));
	}
	m_channel = 2;
}

//+------------------------------------------------------------------
/**
 *	method:	Keithley2182A::auto_range_on
 *
 *	description:	method to execute "AutoRangeON"
 *	This command sets the autorange for the current channel
 *
 *
 */
//+------------------------------------------------------------------
void Keithley2182A::auto_range_on()
{
  CHECK_INTERFACE;

	DEBUG_STREAM << "Keithley2182A::auto_range_on(): entering... !" << endl;

	//	Add your own code to control device here
	if (get_state() != Tango::FAULT)
	{
		if (m_channel == CHANNEL1)
		{
			if (m_autoRange1 == false)
			{
				try
				{
					m_interface->set_autorange_1(true);
				}
				catch (...)
				{
					set_state(Tango::FAULT);
					set_status("Problem communicating with the GPIB device");
					THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
						_CPTC("Problem communicating with the GPIB device"),
						_CPTC("Keithley2182A::auto_range_on"));
				}
				m_autoRange1 = true;
			}
		}

		if (m_channel == CHANNEL2)
		{
			if (m_autoRange2 == false)
			{
				try
				{
					m_interface->set_autorange_2(true);
				}
				catch (...)
				{
					set_state(Tango::FAULT);
					set_status("Problem communicating with the GPIB device");
					THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
						_CPTC("Problem communicating with the GPIB device"),
						_CPTC("Keithley2182A::auto_range_on"));
				}
				m_autoRange2 = true;
			}
		}
	}
	else
	{
		THROW_DEVFAILED(
       _CPTC("BAD_STATE"),
       _CPTC("Action not allowed in this state - Device must be <RUNNING>"),
       _CPTC("Keithley2182A::auto_range_on"));
	}
}

//+------------------------------------------------------------------
/**
 *	method:	Keithley2182A::auto_range_off
 *
 *	description:	method to execute "AutoRangeOFF"
 *	This command unsets the autorange for the current channel
 *
 *
 */
//+------------------------------------------------------------------
void Keithley2182A::auto_range_off()
{
  CHECK_INTERFACE;

	DEBUG_STREAM << "Keithley2182A::auto_range_off(): entering... !" << endl;

	//	Add your own code to control device here
	if (get_state() != Tango::FAULT)
	{
		if (m_channel == CHANNEL1)
		{
			if (m_autoRange1 == true)
			{
				try
				{
					m_interface->set_autorange_1(false);
				}
				catch (...)
				{
					set_state(Tango::FAULT);
					set_status("Problem communicating with the GPIB device");
					THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
						_CPTC("Problem communicating with the GPIB device"),
						_CPTC("Keithley2182A::auto_range_on"));
				}
				m_autoRange1 = false;
			}
		}

		if (m_channel == CHANNEL2)
		{
			if (m_autoRange2 == true)
			{
				try
				{
					m_interface->set_autorange_2(false);
				}
				catch (...)
				{
					set_state(Tango::FAULT);
					set_status("Problem communicating with the GPIB device");
					THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
						_CPTC("Problem communicating with the GPIB device"),
						_CPTC("Keithley2182A::auto_range_on"));
				}
				m_autoRange2 = false;
			}
		}
	}
	else
	{
		THROW_DEVFAILED(
			_CPTC("BAD_STATE"),
			_CPTC("Action not allowed in this state - Device must be <RUNNING>"),
			_CPTC("Keithley2182A::auto_range_off"));
	}
}

//+------------------------------------------------------------------
/**
 *	method:	Keithley2182A::range_up
 *
 *	description:	method to execute "RangeUP"
 *	This command sets the upper range for the current channel
 *
 *
 */
//+------------------------------------------------------------------
void Keithley2182A::range_up()
{
  CHECK_INTERFACE;

	DEBUG_STREAM << "Keithley2182A::range_up(): entering... !" << endl;

	//	Add your own code to control device here
	Tango::DevState st = this->get_state();
	
  if (st == Tango::FAULT) 
	{
		THROW_DEVFAILED(
			_CPTC("BAD_STATE"),
			_CPTC("Action not allowed in this state - Device must be <RUNNING> or <ALARM>"),
			_CPTC("Keithley2182A::range_up"));
	}

	if (m_channel == CHANNEL1)
	{
		if (m_autoRange1 == false)
		{
			std::string l_str;
			l_str = this->get_upper_range();
			try
			{
				m_interface->set_range_1(l_str);
			}
			catch (...)
			{
				set_state(Tango::FAULT);
				set_status("Problem communicating with the GPIB device");
				THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
					_CPTC("Problem communicating with the GPIB device"),
					_CPTC("Keithley2182A::range_up"));
			}
			m_range_1 =  Tango::string_dup(m_interface->get_readable_range_from_set(l_str).data());
		}
		else
		{
			THROW_DEVFAILED(_CPTC("COMMAND FAILURE"),
				_CPTC("RangeUp not possible when autorange is ON"),
				_CPTC("Keithley2182A::range_up"));
		}
	}

	if (m_channel == CHANNEL2)
	{
		if (m_autoRange2 == false)
		{
			std::string l_str;
			l_str = this->get_upper_range();

			try
			{
				m_interface->set_range_2(l_str);
			}
			catch (...)
			{
				set_state(Tango::FAULT);
				set_status("Problem communicating with the GPIB device");
				THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
					_CPTC("Problem communicating with the GPIB device"),
					_CPTC("Keithley2182A::range_up"));
			}
			m_range_2 =  Tango::string_dup(m_interface->get_readable_range_from_set(l_str).data());
		}
		else
		{
			THROW_DEVFAILED(_CPTC("COMMAND FAILURE"),
				_CPTC("RangeUp not possible when autorange is ON"),
				_CPTC("Keithley2182A::range_up"));
		}
	}
}

//+------------------------------------------------------------------
/**
 *	method:	Keithley2182A::range_down
 *
 *	description:	method to execute "RangeDOWN"
 *	This command sets the lower range for the current channel
 *
 *
 */
//+------------------------------------------------------------------
void Keithley2182A::range_down()
{
  CHECK_INTERFACE;

	DEBUG_STREAM << "Keithley2182A::range_down(): entering... !" << endl;

	//	Add your own code to control device here
	Tango::DevState st = this->get_state();

	if (st == Tango::FAULT) 
	{
		THROW_DEVFAILED(
			_CPTC("BAD_STATE"),
			_CPTC("Action not allowed in this state - Device must be <RUNNING> or <ALARM>"),
			_CPTC("Keithley2182A::range_down"));
	}

	if (m_channel == CHANNEL1)
	{
		if (m_autoRange1 == false)
		{
			std::string l_str;
			l_str = this->get_lower_range();try
			{
				m_interface->set_range_1(l_str);
			}
			catch (...)
			{
				set_state(Tango::FAULT);
				set_status("Problem communicating with the GPIB device");
				THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
					_CPTC("Problem communicating with the GPIB device"),
					_CPTC("Keithley2182A::range_down"));
			}
			m_range_1 =  Tango::string_dup(m_interface->get_readable_range_from_set(l_str).data());
		}
		else
		{
			THROW_DEVFAILED(_CPTC("COMMAND FAILURE"),
				_CPTC("RangeDown not possible when autorange is ON"),
				_CPTC("Keithley2182A::range_down"));
		}
	}

	if (m_channel == CHANNEL2)
	{
		if (m_autoRange2 == false)
		{
			std::string l_str;
			l_str = this->get_lower_range();try
			{
				m_interface->set_range_2(l_str);
			}
			catch (...)
			{
				set_state(Tango::FAULT);
				set_status("Problem communicating with the GPIB device");
				THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
					_CPTC("Problem communicating with the GPIB device"),
					_CPTC("Keithley2182A::range_down"));
			}
			m_range_2 =  Tango::string_dup(m_interface->get_readable_range_from_set(l_str).data());
		}
		else
		{
			THROW_DEVFAILED(_CPTC("COMMAND FAILURE"),
				_CPTC("RangeDownp not possible when autorange is ON"),
				_CPTC("Keithley2182A::range_down"));
		}
	}
}

//+------------------------------------------------------------------
/**
 *	method:	Keithley2182A::get_range
 *
 *	description:	method to execute "GetRange"
 *	This command returns the the current range
 *
 * @return	Range value
 *
 */
//+------------------------------------------------------------------
Tango::DevString Keithley2182A::get_range()
{
	//	POGO has generated a method core with argout allocation.
	//	If you would like to use a static reference without copying,
	//	See "TANGO Device Server Programmer's Manual"
	//		(chapter : Writing a TANGO DS / Exchanging data)
	//------------------------------------------------------------
  CHECK_INTERFACE;

	DEBUG_STREAM << "Keithley2182A::get_range(): entering... !" << endl;
	
  Tango::DevString argout;
	//	Add your own code to control device here
	if (get_state() != Tango::FAULT)
	{
		if (m_channel == CHANNEL1)
		{
			try
			{
				m_range_1 = Tango::string_dup(m_interface->read_range_1().data());
			}
			catch (...)
			{
				set_state(Tango::FAULT);
				set_status("Problem communicating with the GPIB device");
				THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
					_CPTC("Problem communicating with the GPIB device"),
					_CPTC("Keithley2182A::get_range"));
			}
			argout = Tango::string_dup(m_range_1);
		} 	

		if (m_channel == CHANNEL2)
		{
			try
			{
				m_range_2 = Tango::string_dup(m_interface->read_range_2().data());
			}
			catch (...)
			{
				set_state(Tango::FAULT);
				set_status("Problem communicating with the GPIB device");
				THROW_DEVFAILED(_CPTC("DEVICE_ERROR"),
					_CPTC("Problem communicating with the GPIB device"),
					_CPTC("Keithley2182A::get_range"));
			}
			argout = Tango::string_dup(m_range_2);
		}
		return argout;
	}
	else
	{
		THROW_DEVFAILED(
			_CPTC("BAD_STATE"),
			_CPTC("Action not allowed in this state - Device must be <RUNNING>"),
			_CPTC("Keithley2182A::get_range"));
	}
}
//+------------------------------------------------------------------
/**
*	method:	Keithley2182A::get_upper_range
*
*	description:	get the upper range
*	This commands returns the value of the upper range 
*
* @return	Value of the upper range
*
*/
//+------------------------------------------------------------------
std::string Keithley2182A::get_upper_range()
{
	DEBUG_STREAM << "Keithley2182A::get_upper_range(): entering... !" << endl;
	//	Add your own code to control device here
	std::string l_str;
	if (m_channel == 1)
	{
		if (strcmp(m_range_1,RR100V) == 0)
		{
			l_str = SETRANGE100V;
		}
		if (strcmp(m_range_1,RR10V) == 0)
		{
			l_str = SETRANGE100V;
		}
		if (strcmp(m_range_1,RR1V) == 0)
		{
			l_str = SETRANGE10V;
		}
		if (strcmp(m_range_1,RR01V) == 0)
		{
			l_str = SETRANGE1V;
		}
		if (strcmp(m_range_1,RR001V) == 0)
		{
			l_str = SETRANGE01V;
		}
	} 
	else
	{
		if (strcmp(m_range_2,RR10V) == 0)
		{
			l_str = SETRANGE10V;
		}
		if (strcmp(m_range_2,RR1V) == 0)
		{
			l_str = SETRANGE10V;
		}
		if (strcmp(m_range_2,RR01V) == 0)
		{
			l_str = SETRANGE1V;
		}
	}
	return l_str;
}

//+------------------------------------------------------------------
/**
*	method:	Keithley2182A::get_lower_range
*
*	description:	get the lower range
*	This commands returns the value of the lower range 
*
* @return	Value of the lower range
*
*/
//+------------------------------------------------------------------
std::string Keithley2182A::get_lower_range()
{
	DEBUG_STREAM << "Keithley2182A::get_lower_range(): entering... !" << endl;
	//	Add your own code to control device here
	std::string l_str;
	if (m_channel == 1)
	{
		if (strcmp(m_range_1,RR001V) == 0)
		{
			l_str = SETRANGE001V;
		}
		if (strcmp(m_range_1,RR01V) == 0)
		{
			l_str = SETRANGE001V;
		}
		if (strcmp(m_range_1,RR1V) == 0)
		{
			l_str = SETRANGE01V;
		}
		if (strcmp(m_range_1,RR10V) == 0)
		{
			l_str = SETRANGE1V;
		}
		if (strcmp(m_range_1,RR100V) == 0)
		{
			l_str = SETRANGE10V;
		}
	} 
	else
	{
		if (strcmp(m_range_2,RR01V) == 0)
		{
			l_str = SETRANGE01V;
		}
		if (strcmp(m_range_2,RR1V) == 0)
		{
			l_str = SETRANGE01V;
		}
		if (strcmp(m_range_2,RR10V) == 0)
		{
			l_str = SETRANGE1V;
		}
	}
	return l_str;
}




}	//	namespace
